function [alpha_cssa]=func_cssa_artifact_removal(V_noise,fs)
    N=length(V_noise); % number of samples or the length of the data
    
    %%  artifacts removal
    L=40;
    comp=9;            % the number of matrices in the SSA
    dmax = max(abs(V_noise)); % the amplitude of the EEG signal
    
    % embeding step in the SSA to map the trajectory matrix X
    [ X ] = func_embedding( V_noise, L);
    
    % SVD step in the SSA to obtain the eigenvalues D_s and elementary matrices Xi
    [D_s,Xi] = func_svd( X,comp);
    
    % the reconstruction stage to obtain the reconstructed components RC
    [ RC ] = func_reconstruction (Xi, N);
    
    % artifact removalto obtian the artifacts: artifact_ssa
    [artifact_ssa ]=func_artifactsremoval(RC,dmax);
    sig_ssa = V_noise - artifact_ssa'; % corrected EEG
%     sig_ssa=V_noise;
    %% CSSA
    L=80;  
    % 켣
    % embeding step in the SSA to map the trajectory matrix X
    [ X ] = func_embedding( sig_ssa, L);
    
    % ֽ
    [XB]=func_matrix_decompositon(sig_ssa,X,L,N);
    
    % Խƽ
    % the reconstruction stage to obtain the reconstructed components RC
    [ RC ] = func_reconstruction (XB, N);
    
    rangeRC=ceil(1+8*L/fs):floor(1+13*L/fs);
    % power spectrum of extracted and simulated alpha
    alpha_cssa=sum(RC(:,rangeRC),2);
end