function [ RC ] = func_reconstruction (Xi, N)

% this function is the reconstruction stage in SSA based on the diagonal averaging step
%   Xi - elementary matrices
%   N  length of data
%   RC - reconstructed componenets

% obtain the number of elementary matrices :comp
[M comp] = size(Xi);

for i=1:comp
    matrix_reconst = Xi{1,i};
    [ row col ] = size(matrix_reconst);
    L = min([ row col ]);
    K = max([ row col ]);

    % diagonal averaging
    for k = 1:N
        if k <= L
            sig_ssa(k) = 0;
            for p = 1:k
                sig_ssa(k) = sig_ssa(k) + matrix_reconst(p,k-p+1);
            end
            sig_ssa(k) = sig_ssa(k)/k;
        
        elseif k <= K
            sig_ssa(k) = 0;
            for p = 1:L
                sig_ssa(k) = sig_ssa(k) + matrix_reconst(p,k-p+1);
            end
            sig_ssa(k) = sig_ssa(k)/L;
        
        elseif k <= N
            sig_ssa(k) = 0;
            for p = k-K+1:N-K+1
                sig_ssa(k) = sig_ssa(k) + matrix_reconst(p,k-p+1);
            end
            sig_ssa(k) = sig_ssa(k)/(N-k+1);
        end
    end
    sig_ssa = sig_ssa';
    RC(:,i) = sig_ssa;
end

end