function [alpha_ssa,sig_ssa]=func_ssa(V_noise,fs,dmax)
%% the main program
L = 40;            % window length of embedding L = 40
comp=9;            % the number of matrices in the SSA
N=length(V_noise); % number of samples or the length of the data
% dmax = max(abs(V_noise)); % the amplitude of the EEG signal

% embeding step in the SSA to map the trajectory matrix X
[ X ] = func_embedding( V_noise, L);
% SVD step in the SSA to obtain the eigenvalues D_s and elementary matrices Xi
[D_s,Xi] = func_svd( X,comp);

% the reconstruction stage to obtain the reconstructed components RC
[ RC ] = func_reconstruction (Xi, N);

% artifact removalto obtian the artifacts: artifact_ssa
[artifact_ssa ]=func_artifactsremoval(RC,dmax);
sig_ssa = V_noise - artifact_ssa'; % corrected EEG

% % alpha rhythm extraction 
[alpha_ssa] = func_rhythmsextraction(RC,D_s,dmax,fs);
end