% this program is the formulation of the adaptive SSA for artifacts removal
% and rhythms extraction of simulated EEG signal 

clc;clear;close all

%% the parameters in the program
fs=200;            % the sampling rate fs = 200Hz

%% the main program
% simulate the EEG based on the MPA model
% [V_noise,V_EEG, V_alpha,V_delta,V_theta,V_beta, time] = func_EEGgenerationMPAmodel(EOG,fs);
load('V_noise.mat'); load('V_EEG.mat');load('V_alpha.mat');
N=length(V_noise); % number of samples or the length of the data
time=(0:N-1)/fs;

% %% CSSA with no artifacts
% L=20;
% % 켣
% % embeding step in the SSA to map the trajectory matrix X
% [ X ] = func_embedding( V_EEG', L);
% 
% % ֽ
% [XB]=func_matrix_decompositon(V_EEG,X,L,N);
% 
% % Խƽ
% % the reconstruction stage to obtain the reconstructed components RC
% [ RC ] = func_reconstruction (XB, N);
% 
% %% RCƵ
% % RCĹ
% col=ceil((6/2));
% f=(0:N-1)*fs/N;
% Nfft=2048; 
% window=kaiser(512,3);   
% noverlap=256;   
% figure
% for i=1:6   
%     [Pp,fp]=pwelch(RC(:,i),window,noverlap,Nfft,fs);
% %     for k=1:10
% %         Pp(k) = 0;
% %     end
%    [maxr,indexr]=max(Pp);
%    f_max(i)=fp(indexr);
%    ff=((i-1)*fs/L)*ones(length(Pp),1);
%    pf=(max(Pp)/length(Pp))*(1:length(Pp));
%    q = num2str(i);
%    t=['RC', q, ' PSD'];
%    subplot(col,2,i)
%    plot(fp,Pp,ff,pf,'--r') 
%    grid on
%    title(t);
%    xlim([0 60])
%    xlabel('f/Hz')
%    ylabel('PSD(uV^2/Hz)')
% end
% 
% % power spectrum of extracted and simulated alpha
% [Pe_20,fp]=pwelch(RC(:,2),window,noverlap,Nfft,fs);
% 
% L=40;
% % 켣
% % embeding step in the SSA to map the trajectory matrix X
% [ X ] = func_embedding( V_EEG', L);
% 
% % ֽ
% [XB]=func_matrix_decompositon(V_EEG,X,L,N);
% 
% % Խƽ
% % the reconstruction stage to obtain the reconstructed components RC
% [ RC ] = func_reconstruction (XB, N);
% 
% %% RCƵ
% % RCĹ
% col=ceil((6/2));
% f=(0:N-1)*fs/N;
% Nfft=2048; 
% window=kaiser(512,3);   
% noverlap=256;   
% figure
% for i=1:6   
%     [Pp,fp]=pwelch(RC(:,i),window,noverlap,Nfft,fs);
% %     for k=1:10
% %         Pp(k) = 0;
% %     end
%    [maxr,indexr]=max(Pp);
%    f_max(i)=fp(indexr);
%    ff=((i-1)*fs/L)*ones(length(Pp),1);
%    pf=(max(Pp)/length(Pp))*(1:length(Pp));
%    q = num2str(i);
%    t=['RC', q, ' PSD'];
%    subplot(col,2,i)
%    plot(fp,Pp,ff,pf,'--r') 
%    grid on
%    title(t);
%    xlim([0 60])
%    xlabel('f/Hz')
%    ylabel('PSD(uV^2/Hz)')
% end
% 
% % power spectrum of extracted and simulated alpha
% [Pe_40,fp]=pwelch(RC(:,3),window,noverlap,Nfft,fs);
% 
% L=80;
% % 켣
% % embeding step in the SSA to map the trajectory matrix X
% [ X ] = func_embedding( V_EEG', L);
% 
% % ֽ
% [XB]=func_matrix_decompositon(V_EEG,X,L,N);
% 
% % Խƽ
% % the reconstruction stage to obtain the reconstructed components RC
% [ RC ] = func_reconstruction (XB, N);
% 
% %% RCƵ
% % RCĹ
% col=ceil((6/2));
% f=(0:N-1)*fs/N;
% Nfft=2048; 
% window=kaiser(512,3);   
% noverlap=256;   
% figure
% for i=1:6   
%     [Pp,fp]=pwelch(RC(:,i),window,noverlap,Nfft,fs);
% %     for k=1:10
% %         Pp(k) = 0;
% %     end
%    [maxr,indexr]=max(Pp);
%    f_max(i)=fp(indexr);
%    ff=((i-1)*fs/L)*ones(length(Pp),1);
%    pf=(max(Pp)/length(Pp))*(1:length(Pp));
%    q = num2str(i);
%    t=['RC', q, ' PSD'];
%    subplot(col,2,i)
%    plot(fp,Pp,ff,pf,'--r') 
%    grid on
%    title(t);
%    xlim([0 60])
%    xlabel('f/Hz')
%    ylabel('PSD(uV^2/Hz)')
% end
% 
% % power spectrum of extracted and simulated alpha
% [Pe_80,fp]=pwelch(RC(:,5)+RC(:,6),window,noverlap,Nfft,fs);
% 
% [Ps,fp]=pwelch(V_alpha,window,noverlap,Nfft,fs);
% figure   
% plot(fp,Pe_20,'b',fp,Pe_40,'g',fp,Pe_80,'r',fp,Ps,'k');
% xlim([0 30])
% xlabel('Frequency (Hz)');ylabel('Power Spectrum (uV^2/Hz)');
% legend('L=20','L=40','L=80','Simulated alpha');
 
%% CSSA with artifacts
L=20;
% 켣
% embeding step in the SSA to map the trajectory matrix X
[ X ] = func_embedding( V_noise', L);

% ֽ
[XB]=func_matrix_decompositon(V_noise,X,L,N);

% Խƽ
% the reconstruction stage to obtain the reconstructed components RC
[ RC ] = func_reconstruction (XB, N);

%% RCƵ
% RCĹ
col=ceil((6/2));
f=(0:N-1)*fs/N;
Nfft=2048; 
window=kaiser(512,3);   
noverlap=256;   
figure
for i=1:6   
    [Pp,fp]=pwelch(RC(:,i),window,noverlap,Nfft,fs);
%     for k=1:10
%         Pp(k) = 0;
%     end
   [maxr,indexr]=max(Pp);
   f_max(i)=fp(indexr);
   ff=((i-1)*fs/L)*ones(length(Pp),1);
   pf=(max(Pp)/length(Pp))*(1:length(Pp));
   q = num2str(i);
   t=['RC', q, ' PSD'];
   subplot(col,2,i)
   plot(fp,Pp,ff,pf,'--r') 
   grid on
   title(t);
   xlim([0 60])
   xlabel('f/Hz')
   ylabel('PSD(uV^2/Hz)')
end

% power spectrum of extracted and simulated alpha
[Pe_20,fp]=pwelch(RC(:,2),window,noverlap,Nfft,fs);

L=40;
% 켣
% embeding step in the SSA to map the trajectory matrix X
[ X ] = func_embedding( V_noise', L);

% ֽ
[XB]=func_matrix_decompositon(V_noise,X,L,N);

% Խƽ
% the reconstruction stage to obtain the reconstructed components RC
[ RC ] = func_reconstruction (XB, N);
alpha_40=RC(:,3);

%% RCƵ
% RCĹ
col=ceil((6/2));
f=(0:N-1)*fs/N;
Nfft=2048; 
window=kaiser(512,3);   
noverlap=256;   
figure
for i=1:6   
    [Pp,fp]=pwelch(RC(:,i),window,noverlap,Nfft,fs);
%     for k=1:10
%         Pp(k) = 0;
%     end
   [maxr,indexr]=max(Pp);
   f_max(i)=fp(indexr);
   ff=((i-1)*fs/L)*ones(length(Pp),1);
   pf=(max(Pp)/length(Pp))*(1:length(Pp));
   q = num2str(i);
   t=['RC', q, ' PSD'];
   subplot(col,2,i)
   plot(fp,Pp,ff,pf,'--r') 
   grid on
   title(t);
   xlim([0 60])
   xlabel('f/Hz')
   ylabel('PSD(uV^2/Hz)')
end

% power spectrum of extracted and simulated alpha
[Pe_40,fp]=pwelch(RC(:,3),window,noverlap,Nfft,fs);

L=80;
% 켣
% embeding step in the SSA to map the trajectory matrix X
[ X ] = func_embedding( V_noise', L);

% ֽ
[XB]=func_matrix_decompositon(V_noise,X,L,N);

% Խƽ
% the reconstruction stage to obtain the reconstructed components RC
[ RC ] = func_reconstruction (XB, N);
alpha_80=RC(:,5)+RC(:,6);

%% RCƵ
% RCĹ
col=ceil((6/2));
f=(0:N-1)*fs/N;
Nfft=2048; 
window=kaiser(512,3);   
noverlap=256;   
figure
for i=1:6   
    [Pp,fp]=pwelch(RC(:,i),window,noverlap,Nfft,fs);
%     for k=1:10
%         Pp(k) = 0;
%     end
   [maxr,indexr]=max(Pp);
   f_max(i)=fp(indexr);
   ff=((i-1)*fs/L)*ones(length(Pp),1);
   pf=(max(Pp)/length(Pp))*(1:length(Pp));
   q = num2str(i);
   t=['RC', q, ' PSD'];
   subplot(col,2,i)
   plot(fp,Pp,ff,pf,'--r') 
   grid on
   title(t);
   xlim([0 60])
   xlabel('f/Hz')
   ylabel('PSD(uV^2/Hz)')
end

% power spectrum of extracted and simulated alpha
[Pe_80,fp]=pwelch(RC(:,5)+RC(:,6),window,noverlap,Nfft,fs);

[Ps,fp]=pwelch(V_alpha,window,noverlap,Nfft,fs);
% figure   
% plot(fp,Pe_20,'b',fp,Pe_40,'g',fp,Pe_80,'r',fp,Ps,'k');
% xlim([0 30])
% xlabel('Frequency (Hz)');ylabel('Power Spectrum (uV^2/Hz)');
% legend('L=20','L=40','L=80','Simulated alpha');


rangeL=20:10:200;
[error]=func_error_alpha(V_noise,rangeL,Ps,fs);
figure
plot(rangeL,error,'.')
% ylim([0.15 0.35]);
xlabel('Embedding demension');ylabel('Error (\muV^2/Hz)');

%% ͨSSAֽǰ6Ԫ
L=40;
comp=9;
% embeding step in the SSA to map the trajectory matrix X
[ X ] = func_embedding( V_noise, L);

% SVD step in the SSA to obtain the eigenvalues D_s and elementary matrices Xi
[D_s,Xi] = func_svd( X,comp);

% the reconstruction stage to obtain the reconstructed components RC
[ RC ] = func_reconstruction (Xi, N);

%% RCƵ
% RCĹ
col=ceil((6/2));
f=(0:N-1)*fs/N;
Nfft=2048; 
window=kaiser(512,3);   
noverlap=256;   
figure
for i=1:6   
    [Pp,fp]=pwelch(RC(:,i),window,noverlap,Nfft,fs);
   [maxr,indexr]=max(Pp);
   f_max(i)=fp(indexr);
   ff=f_max(i);
   pf=(max(Pp)/length(Pp))*(1:length(Pp));
   q = num2str(i);
   t=['RC', q, ' PSD'];
   subplot(col,2,i)
   %    plot(fp,Pp,ff,pf,'--r')
   plot(fp,Pp)
   grid on
   title(t);
   xlim([0 60])
   xlabel('f/Hz')
   ylabel('PSD(uV^2/Hz)')
end

alpha_ssa=RC(:,3)+RC(:,4)+RC(:,5)+RC(:,6);

% power spectrum of extracted and simulated alpha
[Pe_ssa,fp]=pwelch(alpha_ssa,window,noverlap,Nfft,fs);

[Ps,fp]=pwelch(V_alpha,window,noverlap,Nfft,fs);
error_ssa=mean(abs(Ps-Pe_ssa));
figure 
subplot(2,2,1)
plot(time,alpha_40)
ylim([-50 50])
xlabel('Time (s)');ylabel('Amplitude (uV)');
subplot(2,2,2)
plot(time,alpha_80)
ylim([-50 50])
xlabel('Time (s)');ylabel('Amplitude (uV)');
subplot(2,2,3)
plot(time,alpha_ssa)
ylim([-50 50])
xlabel('Time (s)');ylabel('Amplitude (uV)');
subplot(2,2,4)
plot(fp,Ps,'k',fp,Pe_40,'b',fp,Pe_80,'g',fp,Pe_ssa,'r');
xlim([0 15])
xlabel('Frequency (Hz)');ylabel('Power Spectrum (uV^2/Hz)');
legend('Simulated alpha','CSSA,L=40','CSSA,L=80','SSA,L=40');

% power spectrum of extracted and simulated alpha
figure 
subplot(3,2,1)
plot(time,alpha_40)
ylim([-50 50])
xlabel('Time (s)');ylabel('Amplitude (\muV)');
subplot(3,2,3)
plot(time,alpha_80)
ylim([-50 50])
xlabel('Time (s)');ylabel('Amplitude (\muV)');
subplot(3,2,5)
plot(time,alpha_ssa)
ylim([-50 50])
xlabel('Time (s)');ylabel('Amplitude (\muV)');
subplot(3,2,2)
plot(fp,Ps,'b',fp,Pe_40,'r');
xlim([0 15])
xlabel('Frequency (Hz)');ylabel('Power Spectrum (\muV^2/Hz)');
legend('Simulated alpha','CSSA,L=40');
subplot(3,2,4)
plot(fp,Ps,'b',fp,Pe_80,'r');
xlim([0 15])
xlabel('Frequency (Hz)');ylabel('Power Spectrum (\muV^2/Hz)');
legend('Simulated alpha','CSSA,L=80');
subplot(3,2,6)
plot(fp,Ps,'b',fp,Pe_ssa,'r');
xlim([0 15])
xlabel('Frequency (Hz)');ylabel('Power Spectrum (\muV^2/Hz)');
legend('Simulated alpha','SSA,L=40');

%% CSSAIIRWDECĶԱ
[alpha_iir] = func_IIRfiltering(V_noise,fs);
[Pe_iir,fp]=pwelch(alpha_iir,window,noverlap,Nfft,fs);
error_iir=mean(abs(Ps-Pe_iir));
[alpha_wdec] = func_waveletpacketdecomposite(V_noise);
[Pe_wdec,fp]=pwelch(alpha_wdec,window,noverlap,Nfft,fs);
error_wdec=mean(abs(Ps-Pe_wdec));
figure
subplot(1,2,1)
plot(fp,Ps,'b',fp,Pe_80,'g',fp,Pe_iir,'r');
xlim([0 15])
xlabel('Frequency (Hz)');ylabel('Power Spectrum (\muV^2/Hz)');
legend('Simulated alpha','CSSA','IIR');
subplot(1,2,2)
plot(fp,Ps,'b',fp,Pe_80,'g',fp,Pe_wdec,'r');
xlim([0 15])
xlabel('Frequency (Hz)');ylabel('Power Spectrum (\muV^2/Hz)');
legend('Simulated alpha','CSSA','WDec');



