function [D_s,Xi] = func_svd( X,comp)

% this function is the SVD step in the SSA
%   X - trajectory matrix
%   comp - the number of matrices in the SSA we processed, other matrices are considered to be noise and discarded.
%   D_S -  eigenvalues of covariance matrix C = X*X'
%   Xi - the elementary matrices obtained after SVD


C = X*X'; % the covariance matrix

% calculate the eigenvalues and eigenvetors matrix
[V_scores,D_scores] = eig(C);

% the eigenvalues in the decreasing order of magnitude 
D_scores = fliplr(D_scores);
D_scores = flipud(D_scores);
V_scores = fliplr(V_scores);
D_s = sum(D_scores,2);

% the principal components 
Pscore =[];
Pscore = X'*V_scores;

% the elementary matrices
Xi = cell(1,comp);
for i = 1:comp        
    Xi{1,i} = V_scores(:,i)*Pscore(:,i)';
end      

end

