% this program is the formulation of the adaptive SSA for artifacts removal
% and rhythms extraction of simulated EEG signal 

clc;clear;close all

%% the parameters in the program
fs=200;            % the sampling rate fs = 200Hz

%% the main program
% simulate the EEG based on the MPA model
% [V_noise,V_EEG, V_alpha,V_delta,V_theta,V_beta, time] = func_EEGgenerationMPAmodel(EOG,fs);
load('V_noise.mat'); load('V_EEG.mat');load('V_alpha.mat');
N=length(V_noise); % number of samples or the length of the data
time=(0:N-1)/fs;

L=80;
% 켣
% embeding step in the SSA to map the trajectory matrix X
[ X ] = func_embedding( V_noise', L);

% ֽ
[XB]=func_matrix_decompositon(V_noise,X,L,N);

% Խƽ
% the reconstruction stage to obtain the reconstructed components RC
[ RC ] = func_reconstruction (XB, N);
alpha_80=RC(:,5)+RC(:,6);

%% RCƵ
% RCĹ
col=ceil((6/2));
f=(0:N-1)*fs/N;
Nfft=2048; 
window=kaiser(512,3);   
noverlap=256;   
figure
for i=1:6   
    [Pp,fp]=pwelch(RC(:,i),window,noverlap,Nfft,fs);
%     for k=1:10
%         Pp(k) = 0;
%     end
   [maxr,indexr]=max(Pp);
   f_max(i)=fp(indexr);
   ff=((i-1)*fs/L)*ones(length(Pp),1);
   pf=(max(Pp)/length(Pp))*(1:length(Pp));
   q = num2str(i);
   t=['RC', q, ' PSD'];
   subplot(col,2,i)
   plot(fp,Pp,ff,pf,'--r') 
   grid on
   title(t);
   xlim([0 60])
   xlabel('f/Hz')
   ylabel('PSD(uV^2/Hz)')
end

figure
subplot(4,1,1)
plot(time,RC(:,1));
ylim([-50 50])
% ylabel('\muV');
% set(gca,'xtick',[]);
% legend('Delta Rhythm'); 
subplot(4,1,2)
plot(time,RC(:,2));
ylim([-50 50])
% ylabel('\muV');
% set(gca,'xtick',[]);
% legend('Theta Rhythm'); 
subplot(4,1,4)
plot(time,RC(:,6));
ylim([-50 50])
% ylabel('\muV');
xlabel('Time (s)');

figure
plot(time,alpha_80);
ylim([-50 50])
ylabel('\muV');
xlabel('Time (s)');
title('Extracted Alpha Rhythm');



